<?php

/**
* 2018 Wingify (c)
*
* NOTE - You must have a PushCrew account to use this!
*
*  @author    Saurabh Gangwal @ Wingify
*  @copyright Wingify
*  @version   1.0
*  @license   https://pushcrew.com
*/


if (!defined('_PS_VERSION_'))
  exit;

class pushcrew extends Module
{
	public function __construct()
  {
    $this->name = 'pushcrew';
    $this->tab = 'front_office_features';
    $this->version = '1.0';
    $this->author = 'Wingify';
    $this->need_instance = 0;
    $this->ps_versions_compliancy = array('min' => '1.4', 'max' => '1.7');
    //$this->dependencies = array('blockcart');
 
    parent::__construct();
 
    $this->displayName = $this->l('PushCrew');
    $this->description = $this->l('Installing the PushCrew module will automatically insert the PushCrew Smart Code on your PrestaShop website. To get started, you just have to copy the PushCrew Account Id (Your Account ID can be found in the Account Details section under Settings area in the PushCrew dashboard) and paste it in this module\'s configuration.');
    $this->confirmUninstall = $this->l('Are you sure you want to uninstall?');
 
    if (!Configuration::get('PUSHCREW_NAME'))      
      $this->warning = $this->l('No name provided');
  }

public function install()
{
  if (Shop::isFeatureActive())
    Shop::setContext(Shop::CONTEXT_ALL);
 
  return parent::install() &&
    //$this->registerHook('leftColumn') &&
    $this->registerHook('header') &&
    Configuration::updateValue('PUSHCREW_NAME', '');
  }


public function uninstall()
{
  return parent::uninstall() && Configuration::deleteByName('PUSHCREW_NAME');
}


/*public function hookDisplayLeftColumn($params)
{
  $this->context->smarty->assign(
      array(
          'my_module_name' => Configuration::get('MYMODULE_NAME'),
          'my_module_link' => $this->context->link->getModuleLink('mymodule', 'display')
      )
  );
  return $this->display(__FILE__, 'mymodule.tpl');
}
   
public function hookDisplayRightColumn($params)
{
  return $this->hookDisplayLeftColumn($params);
}
   */
public function hookDisplayHeader()
{
  //$this->context->controller->addJS($this->_path.'js/mymodule.js', 'all');
  $this->context->smarty->assign(
      array(
          'my_module_name' => Configuration::get('PUSHCREW_NAME'),
          //'my_module_link' => $this->context->link->getModuleLink('mymodule', 'display')
      )
  );
  return $this->display(__FILE__, 'pushcrew.tpl');
}  

public function getContent()
{
    $output = null;
 
  if (Tools::isSubmit('submit'.$this->name))
    {
        $my_module_name = strval(Tools::getValue('PUSHCREW_NAME'));
        if (ctype_alnum($my_module_name) && (strlen($my_module_name)==32))
        {
          Configuration::updateValue('PUSHCREW_NAME', $my_module_name);
            $output .= $this->displayConfirmation($this->l('Settings updated'));
            //$output .= $this->displayError($this->l('Invalid value'));
        }
        else
        {
                    Configuration::updateValue('PUSHCREW_NAME', $my_module_name);
                      $output .= $this->displayError($this->l('Invalid value'));
            //Configuration::updateValue('MYMODULE_NAME', $my_module_name);
            //$output .= $this->displayConfirmation($this->l('Settings updated'));
        }
    } 
    return $output.$this->displayForm();
}

public function displayForm()
{
    // Get default language
    $default_lang = (int)Configuration::get('PS_LANG_DEFAULT');
     
    // Init Fields form array
    $fields_form[0]['form'] = array(
        'legend' => array(
            'title' => $this->l('Settings'),
        ),
        'input' => array(
            array(
                'type' => 'text',
                'label' => $this->l('PushCrew Account ID'),
                'name' => 'PUSHCREW_NAME',
                'size' => 20,
                'required' => true
            )
        ),
        'submit' => array(
            'title' => $this->l('Save'),
            'class' => 'btn btn-default pull-left'
        )
    );
     
    $helper = new HelperForm();
     
    // Module, token and currentIndex
    $helper->module = $this;
    $helper->name_controller = $this->name;
    $helper->token = Tools::getAdminTokenLite('AdminModules');
    $helper->currentIndex = AdminController::$currentIndex.'&configure='.$this->name;
     
    // Language
    $helper->default_form_language = $default_lang;
    $helper->allow_employee_form_lang = $default_lang;
     
    // Title and toolbar
    $helper->title = $this->displayName;
    $helper->show_toolbar = true;        // false -> remove toolbar
    $helper->toolbar_scroll = true;      // yes - > Toolbar is always visible on the top of the screen.
    $helper->submit_action = 'submit'.$this->name;
    $helper->toolbar_btn = array(
        'save' =>
        array(
            'desc' => $this->l('Save'),
            'href' => AdminController::$currentIndex.'&configure='.$this->name.'&save'.$this->name.
            '&token='.Tools::getAdminTokenLite('AdminModules'),
        ),
        'back' => array(
            'href' => AdminController::$currentIndex.'&token='.Tools::getAdminTokenLite('AdminModules'),
            'desc' => $this->l('Back to list')
        )
    );
     
    // Load current value
    $helper->fields_value['PUSHCREW_NAME'] = Configuration::get('PUSHCREW_NAME');
     
    return $helper->generateForm($fields_form);
}

}

?>